#include <stdio.h>
#include <net/if.h>
#include <linux/sockios.h>

main(int argc, char **argv)
{
	int p[5];
	int fd = socket(AF_INET, SOCK_DGRAM, 0);
	struct ifreq ifr;

	if (argc < 2)
		goto oops;
	argc--; argv++;

	strcpy(ifr.ifr_name, argv[0]);
	ifr.ifr_data = p;
	
	if (ioctl(fd, SIOCDEVPRIVATE+1, &ifr))
		goto oops;

	if (argc > 1) {
		argc--;

		while (argc > 0) {
			argv++; argc--;
			if (strcmp(*argv, "tx_coal") == 0) {
				argc--; argv++;
				if (argc < 0)
					goto oops;
				p[0] = atoi(*argv);
			} else if (strcmp(*argv, "tx_desc") == 0) {
				argc--; argv++;
				if (argc < 0)
					goto oops;
				p[1] = atoi(*argv);
			} else if (strcmp(*argv, "rx_coal") == 0) {
				argc--; argv++;
				if (argc < 0)
					goto oops;
				p[2] = atoi(*argv);
			} else if (strcmp(*argv, "rx_desc") == 0) {
				argc--; argv++;
				if (argc < 0)
					goto oops;
				p[3] = atoi(*argv);
			} else if (strcmp(*argv, "rx_idle") == 0) {
				argc--; argv++;
				if (argc < 0)
					goto oops;
				p[4] = atoi(*argv);
			} else
				goto oops;
		}

		if (ioctl(fd, SIOCDEVPRIVATE+2, &ifr))
			goto oops;
	}

	printf("tx_coal\t%d\n", p[0]);
	printf("tx_desc\t%d\n", p[1]);
	printf("rx_coal\t%d\n", p[2]);
	printf("rx_desc\t%d\n", p[3]);
	printf("rx_idle(or tx_ratio)\t%d\n", p[4]);
	exit(0);

oops:
	fprintf(stderr, "Something is wrong, sorry\n");
	fprintf(stderr, "Usage: acecoal DEVICE [ tx_coal | rx_coal | tx_desc | rx_desc | rx_idle ]\n");
	exit(-1);
}
